Attribute VB_Name = "HDRoutines"
Option Explicit

'
'   D I S K    O P E R A T I O N S
'

' inserts organism file in the simulation
' remember that organisms could be made of more than one robot
Public Sub InsertOrganism(path As String)
  Dim x As Single, Y As Single
  x = Random(Form1.ScaleLeft, Form1.ScaleWidth)
  Y = Random(Form1.ScaleTop, Form1.ScaleHeight)
  LoadOrganism path, x, Y
End Sub

' saves organism file
Public Sub SaveOrganism(path As String, r As Integer)
  Dim clist(50) As Integer
  Dim k As Integer, cnum As Integer
  k = 0
  clist(0) = r
  ListCells clist()
  While clist(cnum) > 0
    cnum = cnum + 1
  Wend
  Open path For Binary As 1
    Put #1, , cnum
    For k = 0 To cnum - 1
      SaveRobotBody 1, clist(k)
    Next k
  Close 1
End Sub

' loads an organism file
Public Sub LoadOrganism(path As String, x As Single, Y As Single)
  Dim clist(50) As Integer
  Dim OList(50) As Integer
  Dim k As Integer, cnum As Integer
  Dim nuovo As Integer
  Open path For Binary As 1
    Get #1, , cnum
    For k = 0 To cnum - 1
      nuovo = posto()
      clist(k) = nuovo
      LoadRobot 1, nuovo
      rob(nuovo).Y = rob(nuovo).Y
    Next k
  Close 1
  If x > -1 And Y > -1 Then
    PlaceOrganism clist(), x, Y
  End If
  RemapTies clist(), OList, cnum
  For k = 0 To cnum - 1
    rlist.addrobot clist(k), rob(clist(k)).x
  Next k
End Sub

' places an organism (made of robots listed in clist())
' in the specified x,y positions
Public Sub PlaceOrganism(clist() As Integer, x As Single, Y As Single)
  Dim k As Integer
  Dim dx As Single, dy As Single
  dx = x - rob(clist(0)).x
  dy = Y - rob(clist(0)).Y
  While clist(k) > 0
    rob(clist(k)).x = rob(clist(k)).x + dx
    rob(clist(k)).Y = rob(clist(k)).Y + dy
    k = k + 1
  Wend
End Sub

' remaps ties from the old index numbers - those the robots had
' when saved to disk- to the new indexes assigned in this simulation
Public Sub RemapTies(clist() As Integer, OList() As Integer, cnum As Integer)
  Dim t As Integer, ind As Integer, j As Integer, k As Integer
  For t = 0 To cnum - 1
    ind = OList(t)
    For k = 0 To cnum - 1
      j = 1
      While rob(clist(k)).ties(j).pnt > 0
        If rob(clist(k)).ties(j).pnt = ind Then
          rob(clist(k)).ties(j).pnt = clist(t)
        End If
        j = j + 1
      Wend
    Next k
  Next t
End Sub

' saves a whole simulation
Public Sub SaveSimulation(path As String)
  Dim t As Integer
  Open path For Binary As 1
    
    Put #1, , MaxRobs
    
    For t = 1 To MaxRobs
      SaveRobotBody 1, t
    Next t
    
    Put #1, , CInt(Len(SimOpts.AutoRobPath))
    Put #1, , SimOpts.AutoRobPath
    Put #1, , SimOpts.AutoRobTime
    Put #1, , CInt(Len(SimOpts.AutoSimPath))
    Put #1, , SimOpts.AutoSimPath
    Put #1, , SimOpts.AutoSimTime
    Put #1, , SimOpts.BlockedVegs
    Put #1, , SimOpts.CostChem
    Put #1, , SimOpts.CostExecCond
    Put #1, , SimOpts.CostStore
    Put #1, , SimOpts.DBEnable
    Put #1, , SimOpts.DBExcludeVegs
    Put #1, , CInt(Len(SimOpts.DBName))
    Put #1, , SimOpts.DBName
    Put #1, , SimOpts.DBRecDna
    Put #1, , SimOpts.DisableTies
    Put #1, , SimOpts.EnergyExType
    Put #1, , SimOpts.EnergyFix
    Put #1, , SimOpts.EnergyProp
    Put #1, , SimOpts.FieldHeight
    Put #1, , SimOpts.FieldSize
    Put #1, , SimOpts.FieldWidth
    Put #1, , SimOpts.KillDistVegs
    Put #1, , SimOpts.MaxEnergy
    Put #1, , SimOpts.MaxPopulation
    Put #1, , SimOpts.MinVegs
    Put #1, , SimOpts.MutCurrMult
    Put #1, , SimOpts.MutCycMax
    Put #1, , SimOpts.MutCycMin
    Put #1, , SimOpts.MutOscill
    Put #1, , SimOpts.PhysBrown
    Put #1, , SimOpts.PhysFriction
    Put #1, , SimOpts.PhysGrav
    Put #1, , SimOpts.PhysMoving
    Put #1, , SimOpts.PhysSwim
    Put #1, , SimOpts.PopLimMethod
    Put #1, , CInt(Len(SimOpts.SimName))
    Put #1, , SimOpts.SimName
    Put #1, , SimOpts.SpeciesNum
    Put #1, , SimOpts.Toroidal
    Put #1, , SimOpts.TotBorn
    Put #1, , SimOpts.TotRunCycle
    Put #1, , SimOpts.TotRunTime
    
    'new stuff
    
    Put #1, , SimOpts.Pondmode
    Put #1, , SimOpts.KineticEnergy
    Put #1, , SimOpts.LightIntensity
    Put #1, , SimOpts.CorpseEnabled
    Put #1, , SimOpts.Decay
    Put #1, , SimOpts.Gradient
    Put #1, , SimOpts.DayNight
    Put #1, , SimOpts.CycleLength
    
    'new new stuff
    
    Put #1, , SimOpts.Decaydelay
    Put #1, , SimOpts.DecayType
    Put #1, , SimOpts.MoveCost
    Put #1, , SimOpts.F1
    Put #1, , SimOpts.Restart
    
    'even even newer newer stuff
    Put #1, , SimOpts.Dxsxconnected
    Put #1, , SimOpts.Updnconnected
    Put #1, , SimOpts.RepopAmount
    Put #1, , SimOpts.RepopCooldown
    Put #1, , SimOpts.ZeroMomentum
    Put #1, , SimOpts.UserSeedNumber
    Put #1, , SimOpts.UserSeedToggle
  Close 1
End Sub

' loads a whole simulation
Public Sub LoadSimulation(path As String)
  Dim j As Integer
  Dim k As Integer
  
  rlist.deleteall
  Erase rob()
  For k = 0 To RobArrayMax
    ReDim rob(k).DNA(100)
  Next k
  
  Open path For Binary As 1
    
    Get #1, , MaxRobs
    
    For k = 1 To MaxRobs
      LoadRobot 1, k
    Next k
    
    Get #1, , k: SimOpts.AutoRobPath = Space(k)
    Get #1, , SimOpts.AutoRobPath
    Get #1, , SimOpts.AutoRobTime
    Get #1, , k: SimOpts.AutoSimPath = Space(k)
    Get #1, , SimOpts.AutoSimPath
    Get #1, , SimOpts.AutoSimTime
    Get #1, , SimOpts.BlockedVegs
    Get #1, , SimOpts.CostChem
    Get #1, , SimOpts.CostExecCond
    Get #1, , SimOpts.CostStore
    Get #1, , SimOpts.DBEnable
    Get #1, , SimOpts.DBExcludeVegs
    Get #1, , k: SimOpts.DBName = Space(k)
    Get #1, , SimOpts.DBName
    Get #1, , SimOpts.DBRecDna
    Get #1, , SimOpts.DisableTies
    Get #1, , SimOpts.EnergyExType
    Get #1, , SimOpts.EnergyFix
    Get #1, , SimOpts.EnergyProp
    Get #1, , SimOpts.FieldHeight
    Get #1, , SimOpts.FieldSize
    Get #1, , SimOpts.FieldWidth
    Get #1, , SimOpts.KillDistVegs
    Get #1, , SimOpts.MaxEnergy
    Get #1, , SimOpts.MaxPopulation
    Get #1, , SimOpts.MinVegs
    Get #1, , SimOpts.MutCurrMult
    Get #1, , SimOpts.MutCycMax
    Get #1, , SimOpts.MutCycMin
    Get #1, , SimOpts.MutOscill
    Get #1, , SimOpts.PhysBrown
    Get #1, , SimOpts.PhysFriction
    Get #1, , SimOpts.PhysGrav
    Get #1, , SimOpts.PhysMoving
    Get #1, , SimOpts.PhysSwim
    Get #1, , SimOpts.PopLimMethod
    Get #1, , k: SimOpts.SimName = Space(k)
    Get #1, , SimOpts.SimName
    Get #1, , SimOpts.SpeciesNum
    Get #1, , SimOpts.Toroidal
    Get #1, , SimOpts.TotBorn
    Get #1, , SimOpts.TotRunCycle
    Get #1, , SimOpts.TotRunTime
    'new stuff
   
    If Not EOF(1) Then Get #1, , SimOpts.Pondmode
    If Not EOF(1) Then Get #1, , SimOpts.KineticEnergy
    If Not EOF(1) Then Get #1, , SimOpts.LightIntensity
    If Not EOF(1) Then Get #1, , SimOpts.CorpseEnabled
    If Not EOF(1) Then Get #1, , SimOpts.Decay
    If Not EOF(1) Then Get #1, , SimOpts.Gradient
    If Not EOF(1) Then Get #1, , SimOpts.DayNight
    If Not EOF(1) Then Get #1, , SimOpts.CycleLength
        
    'even newer stuff
    
    If Not EOF(1) Then Get #1, , SimOpts.Decaydelay
    If Not EOF(1) Then Get #1, , SimOpts.DecayType
    If Not EOF(1) Then Get #1, , SimOpts.MoveCost
    If Not EOF(1) Then Get #1, , SimOpts.F1
    If Not EOF(1) Then Get #1, , SimOpts.Restart
    
    'even even newer newer stuff
    If Not EOF(1) Then Get #1, , SimOpts.Dxsxconnected
    If Not EOF(1) Then Get #1, , SimOpts.Updnconnected
    If Not EOF(1) Then Get #1, , SimOpts.RepopAmount
    If Not EOF(1) Then Get #1, , SimOpts.RepopCooldown
    If Not EOF(1) Then Get #1, , SimOpts.ZeroMomentum
    If Not EOF(1) Then Get #1, , SimOpts.UserSeedNumber
    If Not EOF(1) Then Get #1, , SimOpts.UserSeedToggle
    
  Close 1
End Sub

' loads a single robot
Public Sub LoadRobot(fnum As Integer, n As Integer)
  LoadRobotBody 1, n
  If rob(n).Exist Then
    GiveAbsNum n
    insertsysvars n
    ScanUsedVars n
    makecondlist n
    makeoccurrlist n
    countconditions n
    rob(n).DnaLen = DNALength(n)
    rlist.addrobot n, rob(n).x
  End If
End Sub

' assignes a robot his unique code
Private Sub GiveAbsNum(k As Integer)
  Dim n As node, max As Long
  Set n = rlist.firstnode
  While Not (n Is rlist.last)
    If max < rob(n.robn).AbsNum Then
      max = rob(n.robn).AbsNum
    End If
    Set n = n.pn
  Wend
  rob(k).AbsNum = max + 1
End Sub

' saves a single robot
Public Sub SaveRobot(n As Integer, path As String)
  Open path For Binary As 1
    SaveRobotBody 1, n
  Close 1
End Sub
' loads the body of the robot
Private Sub LoadRobotBody(n As Integer, r As Integer)
'robot r
'file #n,
  Dim t As Integer, k As Integer, ind As Integer
  With rob(r)
  
    Get #n, , .Veg
    Get #n, , .Wall
    Get #n, , .Fixed
    
    Get #n, , .x
    Get #n, , .Y
    Get #n, , .vx
    Get #n, , .vy
    Get #n, , .aim
    Get #n, , .ma           'momento angolare
    Get #n, , .mt           'momento torcente
     
    'ties
    For t = 0 To 10
      Get #n, , .ties(t).Port
      Get #n, , .ties(t).pnt
      Get #n, , .ties(t).ptt
      Get #n, , .ties(t).ang
      Get #n, , .ties(t).bend
      Get #n, , .ties(t).angreg
      Get #n, , .ties(t).ln
      Get #n, , .ties(t).shrink
      Get #n, , .ties(t).stat
      Get #n, , .ties(t).last
      Get #n, , .ties(t).mem
      Get #n, , .ties(t).back
      Get #n, , .ties(t).nrgused
      Get #n, , .ties(t).infused
      Get #n, , .ties(t).sharing
    Next t
    
    Get #n, , .nrg: If .nrg < 10 Then .nrg = 10
    
    For t = 1 To 50
      Get #n, , k: .vars(t).Name = Space(k)
      Get #n, , .vars(t).Name   '|
      Get #n, , .vars(t).value
    Next t
    Get #n, , .vnum             '| variabili private
    
    ' macchina virtuale
    Get #n, , .mem()       ' memoria dati
    Get #n, , k: ReDim .DNA(k)
    
    For t = 1 To k
      Get #n, , .DNA(t).tipo
      Get #n, , .DNA(t).value
    Next t
        
    For t = 0 To 20
      Get #n, , .mutarray(t)
    Next t
    
    ' informative
    Get #n, , .SonNumber
    Get #n, , .Mutations
    Get #n, , .LastMut
    Get #n, , .Parent
    Get #n, , .age
    Get #n, , .BirthCycle
    Get #n, , .genenum
    Get #n, , .generation
    Get #n, , .DnaLen
    
    ' aspetto
    Get #n, , .Skin()
    Get #n, , .color
    
    'new stuff using EOF conditions for backward compatability
    'new stuff
    If Not EOF(1) Then Get #n, , .body: If .body < 10 Then .body = 10: .Radius = .body / factor
    If Not EOF(1) Then Get #n, , .Bouyancy
    If Not EOF(1) Then Get #n, , .Corpse
    If Not EOF(1) Then Get #n, , .Pwaste
    If Not EOF(1) Then Get #n, , .Waste
    If Not EOF(1) Then Get #n, , .poison
    If Not EOF(1) Then Get #n, , .venom
    If Not EOF(1) Then Get #n, , .Shape
    If Not EOF(1) Then Get #n, , .Exist
    If Not EOF(1) Then Get #n, , .Dead
    
    If Not EOF(1) Then Get #1, , k: .fname = Space(k)
    If Not EOF(1) Then Get #1, , .fname
    
    If Not EOF(1) Then Get #1, , k: .LastOwner = Space(k)
    If Not EOF(1) Then Get #1, , .LastOwner
  End With
End Sub
' saves the body of the robot
Private Sub SaveRobotBody(n As Integer, r As Integer)
  Dim t As Integer, k As Integer
  With rob(r)
    
    Put #n, , .Veg
    Put #n, , .Wall
    Put #n, , .Fixed
    
    ' fisiche
    Put #n, , .x
    Put #n, , .Y
    Put #n, , .vx
    Put #n, , .vy
    Put #n, , .aim
    Put #n, , .ma           'momento angolare
    Put #n, , .mt           'momento torcente
    
    For t = 0 To 10
      Put #n, , .ties(t).Port
      Put #n, , .ties(t).pnt
      Put #n, , .ties(t).ptt
      Put #n, , .ties(t).ang
      Put #n, , .ties(t).bend
      Put #n, , .ties(t).angreg
      Put #n, , .ties(t).ln
      Put #n, , .ties(t).shrink
      Put #n, , .ties(t).stat
      Put #n, , .ties(t).last
      Put #n, , .ties(t).mem
      Put #n, , .ties(t).back
      Put #n, , .ties(t).nrgused
      Put #n, , .ties(t).infused
      Put #n, , .ties(t).sharing
    Next t
    
    ' biologiche
    Put #n, , .nrg
    
    'custom variables we're saving
    For t = 1 To 50
      Put #n, , CInt(Len(.vars(t).Name))
      Put #n, , .vars(t).Name         '|
      Put #n, , .vars(t).value
    Next t

    Put #n, , .vnum            '| variabili private
    
    ' macchina virtuale
    Put #n, , .mem()
    k = DnaLen(.DNA()): Put #n, , k
    For t = 1 To k
      Put #n, , .DNA(t).tipo
      Put #n, , .DNA(t).value
    Next t
    
    For t = 0 To 20
      Put #n, , .mutarray(t)
    Next t
    
    ' informative
    Put #n, , .SonNumber
    Put #n, , .Mutations
    Put #n, , .LastMut
    Put #n, , .Parent
    Put #n, , .age
    Put #n, , .BirthCycle
    Put #n, , .genenum
    Put #n, , .generation
    Put #n, , .DnaLen
    
    ' aspetto

    Put #n, , .Skin()
    Put #n, , .color
    
    ' new features
    Put #n, , .body
    Put #n, , .Bouyancy
    Put #n, , .Corpse
    Put #n, , .Pwaste
    Put #n, , .Waste
    Put #n, , .poison
    Put #n, , .venom
    Put #n, , .Shape
    Put #n, , .Exist
    Put #n, , .Dead
    
    Put #1, , CInt(Len(.fname))
    Put #1, , .fname
    
    Put #1, , CInt(Len(.LastOwner))
    Put #1, , .LastOwner
    
  End With
End Sub

' saves a robot dna     !!!New routine from Carlo!!!
Sub salvarob(n As Integer, path As String, Optional nombox As Boolean)
  Dim t As Integer
  Dim a As String
  Dim ti As Byte
  Dim va As Integer
  Dim hold As String
  Dim hashed As String
  t = 1
  Open path For Output As #1
  SaveRobHeader n, 1, hold
  While Not (rob(n).DNA(t).tipo = 4 And rob(n).DNA(t).value = 4)
    ti = rob(n).DNA(t).tipo
    va = rob(n).DNA(t).value
    Select Case rob(n).DNA(t).tipo
      Case 0
        If rob(n).DNA(t + 1).tipo = 2 And rob(n).DNA(t + 1).value = 1 Then
          PrintH 1, "  " & varname(va), hold
        Else
          PrintH 1, " " + Str$(va), hold
        End If
      Case 1
        a = varname(va)
        PrintH 1, "  " + "*" + a, hold
      Case 2
        Select Case va
          Case 1
            PrintH 1, "  store", hold
          Case 3
            PrintH 1, "  add", hold
          Case 4
            PrintH 1, "  sub", hold
          Case 5
            PrintH 1, "  mult", hold
          Case 6
            PrintH 1, "  div", hold
          Case 7
            PrintH 1, "  rnd", hold
          Case 8
            PrintH 1, "  inc", hold
          Case 9
            PrintH 1, "  dec", hold
          Case 10
            PrintH 1, "  angle", hold
          Case 11
            PrintH 1, "  dist", hold
          Case 12
            PrintH 1, " addstore", hold
          Case 13
            PrintH 1, " substore", hold
          Case 14
            PrintH 1, " divstore", hold
          Case 15
            PrintH 1, " multstore", hold
          Case 16
            Print #1, " mod", hold
          Case 17
            Print #1, " ceil", hold
          Case 18
            Print #1, " floor", hold
          Case 19
            PrintH 1, " sqr", hold
          Case 20
            PrintH 1, " ^", hold
          Case 21
            PrintH 1, " sgn", hold
          Case 22
            PrintH 1, " abs", hold
          Case 23
            PrintH 1, " dup", hold
          Case 24
            PrintH 1, " pyth", hold
        End Select
      Case 3
        Select Case va
          Case 1
            PrintH 1, "  <", hold
          Case 2
            PrintH 1, "  >", hold
          Case 3
            PrintH 1, "  =", hold
          Case 4
            PrintH 1, "  !=", hold
          Case 5
            PrintH 1, "  %=", hold
          Case 6
            PrintH 1, "  !%=", hold
          Case 7
            PrintH 1, "  ~=", hold
          Case 8
            PrintH 1, "  !~=", hold
          Case 9
            PrintH 1, "  >=", hold
          Case 10
            PrintH 1, "  <=", hold
        End Select
      Case 4
        Select Case va
          Case 1
            PrintH 1, "", hold
            PrintH 1, "cond", hold
          Case 2
            PrintH 1, "start", hold
          Case 3
            PrintH 1, "stop", hold
          Case 4
            PrintH 1, "end", hold
        End Select
        Case 5
        Select Case va
          Case 1
            PrintH 1, "and", hold
          Case 2
            PrintH 1, "or", hold
          Case 3
            PrintH 1, "xor", hold
          Case 4
            PrintH 1, "not", hold
        End Select
      End Select
    t = t + 1
  Wend

  PrintH 1, "end", hold
  hashed = Hash(hold, 20)
  Print #1, ""
  Print #1, "'#hash: " + hashed
  Close #1
  If Not nombox Then
    If MsgBox("Do you want to change robot's name to " + extractname(path) + " ?", vbYesNo, "Robot DNA saved") = vbYes Then
      rob(n).fname = extractname(path)
    End If
  End If
End Sub

Public Function Load_League_File(Leaguename As String) As Integer
'returns -1 if league doesn't exist,
'0 if successful,
'[1-30] if a robot in the list doesn't exist
'-2 if leaguefile exists but not directory
'-3 if leaguefile contains too many entrants
'-4 if leaguefile contains too few entrants
'-5 if leaguefile contains an unknown error
  Dim filename As String
  Dim Line As String
  Dim singlecharacter As String
  Dim currpos As Long
  Dim robotname As String
  Dim robotcomment As String
  Dim length As Long
 
  filename = MDIForm1.MainDir + "\Leagues\" + Leaguename + "leaguetable.txt"
  
  On Error GoTo Nosuchfile
  Open filename For Input As 1
    
  Line Input #1, Line
  Line = Line + "'"
  currpos = 1
  singlecharacter = mid(Line, currpos, 1)
  
  On Error GoTo invalidfile
  While True
    While singlecharacter <> "#"
      If singlecharacter = "1" Then
        If left(Line, 3) = "1 -" Then
          'start of robot list, exit physics loop
          GoTo endloop
        End If
      End If
      
      currpos = currpos + 1
      If singlecharacter = "'" Then
        Line Input #1, Line
        currpos = 1
        singlecharacter = mid(Line, currpos, 1)
      End If
    Wend
    
    'we now have the pos of a physics line
    If mid(Line, currpos, 3) = "#F1" Then
      SimOpts.F1 = True
      SimOpts.CorpseEnabled = False
      SimOpts.CostChem = 2
      SimOpts.CostExecCond = 0.004
      SimOpts.CostStore = 0.04
      SimOpts.DayNight = False
      SimOpts.FieldWidth = 9237
      SimOpts.FieldHeight = 6928
      SimOpts.FieldSize = 1
      SimOpts.MaxEnergy = 40
      SimOpts.MaxPopulation = 25
      SimOpts.MinVegs = 10
      SimOpts.Pondmode = False
      SimOpts.PhysFriction = 1
      SimOpts.PhysBrown = 0
      SimOpts.PhysGrav = 0
      SimOpts.Toroidal = True
      SimOpts.MoveCost = 0.5
    Else
      'custom physics.
    End If
    
    Line Input #1, Line
    singlecharacter = mid(Line, currpos, 1)
  Wend
endloop:
  
  'we are now at the start of the robot declaration list.  Add these robots to
  'the league table
  Dim Index As Integer
  
  For Index = 0 To 30
    filename = MDIForm1.MainDir + "\Leagues\" + Leaguename + "league\" 'directory of league robots
    Line = Line + "'"
    
    length = InStr(Line, "'") - 1
    If right(left(Line, length), 1) = " " Then length = length - 1
    robotname = left(Line, length)
    robotcomment = right(Line, Len(Line) - length)
    robotcomment = left(robotcomment, Len(robotcomment) - 1)
    robotname = right(robotname, Len(robotname) - 4) 'takes everything besides teh "1 - " at start of line and " 'blah..." at end of line
    If robotname = "EMPTY" Or robotname = "" Then
      Add_Blank_Specie Index
    Else
      robotname = filename + robotname + ".txt" 'now we have the path and filename of the robot
      'add robot robotname to LeagueEntrants array
      Add_Specie robotname, Index, robotcomment
    End If
    
    If EOF(1) Then GoTo endloop2
    
    Line Input #1, Line
  Next Index
endloop2:
  
  Index = Index + 1
  'write emptys to the rest of the array
  For Index = Index To 30
    Add_Blank_Specie Index
  Next Index
  
  Close_League_File
  Load_League_File = 0
  Exit Function
  
Nosuchfile:
  Close_League_File
  MsgBox filename + " doesn't exist.", vbOKOnly, "League File Not Found"
  Load_League_File = -1
  Exit Function
invalidfile:
  Close_League_File
  MsgBox "Error reading from " + filename + ".  Abandoning attempt.", vbOKOnly, "File Reading Error"
  Load_League_File = -5
  Exit Function
End Function

Public Sub Close_League_File()
  Close 1
End Sub

Private Sub Add_Specie(path As String, k As Integer, leaguecomment As String)
  LeagueEntrants(k).Posrg = Form1.width
  LeagueEntrants(k).Posdn = Form1.Height
  LeagueEntrants(k).Poslf = 0
  LeagueEntrants(k).Postp = 0
  LeagueEntrants(k).Name = extractname(path)
  LeagueEntrants(k).path = extractpath(path)
  LeagueEntrants(k).path = relpath(LeagueEntrants(k).path)
  LeagueEntrants(k).Veg = False
  LeagueEntrants(k).color = vbBlue
  Dim t As Integer
  LeagueEntrants(k).Mutations = False
  'For t = 0 To 15
  '  LeagueEntrants(k).mutarray(t) = 0
  'Next t
  LeagueEntrants(k).qty = 5
  LeagueEntrants(k).Stnrg = 3000
  LeagueEntrants(k).Fixed = False
  
  Dim i As Integer
  For i = 0 To 7 Step 2
      LeagueEntrants(k).Skin(i) = Random(0, RobSizePublic / 2)
      LeagueEntrants(k).Skin(i + 1) = Random(0, 628)
  Next i
  
  LeagueEntrants(k).Leaguefilecomment = leaguecomment
End Sub

Private Sub Add_Blank_Specie(k As Integer)
  Dim specie As datispecie
   
  LeagueEntrants(k) = specie
End Sub

Public Function Save_League_File(Name As String) As Integer
  Dim filename As String
  Dim tofilename As String
  Dim Line As String
  Dim singlecharacter As String
  Dim currpos As Long
  Dim robotname As String
  Dim length As Long
  Dim loopdone As Boolean
  Dim originalleague As Boolean
 
  filename = MDIForm1.MainDir + "\Leagues\" + Leaguename + "leaguetable.txt"
  tofilename = MDIForm1.MainDir + "\Leagues\" + Leaguename + "leaguetable.tmp"
    
  On Error GoTo Nosuchfile
  Open filename For Input As 1
enderror:
   
  On Error GoTo Problem
  Open tofilename For Output As 2
    
  If originalleague = False Then
    Line Input #1, Line
    If left(Line, 4) = "1 - " Then loopdone = True
    While Not loopdone And Not EOF(1)
      Print #2, Line
      Line Input #1, Line
      If left(Line, 4) = "1 - " Then loopdone = True
    Wend
  Else
    Line = "'New league created by program."
    Print #2, Line
    Line = "#F1"
    Print #2, Line
  End If
  
  'now we write robot data
  
  If Dir$(MDIForm1.MainDir + "\Leagues\" + Leaguename + "league\*.*") = "" Then
    MkDir MDIForm1.MainDir + "\Leagues\" + Leaguename + "league"
  End If
  
  Dim Index As Integer
  For Index = 1 To 9
    Line = Index
    Line = Line + " - "
    If LeagueEntrants(Index - 1).Name = "" Then LeagueEntrants(Index - 1).Name = "EMPTY.TXT"
    Line = Line + left(LeagueEntrants(Index - 1).Name, Len(LeagueEntrants(Index - 1).Name) - 4)
    Line = Line + LeagueEntrants(Index - 1).Leaguefilecomment
    Print #2, Line
    
    If Not LeagueEntrants(Index - 1).Name = "EMPTY.TXT" Then
      'if this robot doesn't exist in the league directory, copy its file to the league directory
      If Dir$(MDIForm1.MainDir + "\Leagues\" + Leaguename + "league\" + LeagueEntrants(Index - 1).Name) = "" And LeagueEntrants(Index - 1).Name <> "" Then
        Dim tempstring As String
      
        tempstring = LeagueEntrants(Index - 1).path + "\" + LeagueEntrants(Index - 1).Name
        If (left(tempstring, 2) = "&#") Then
          tempstring = MDIForm1.MainDir + right(tempstring, Len(tempstring) - 2)
        End If
        If Dir$(tempstring) <> "" Then
          FileCopy tempstring, MDIForm1.MainDir + "\Leagues\" + Leaguename + "league\" + LeagueEntrants(Index - 1).Name
        Else
          MsgBox "Error copying " + LeagueEntrants(Index - 1).path + "\" + LeagueEntrants(Index - 1).Name + " into league directory.  Continuing...", vbOKOnly, "Copy File Error"
        End If
      End If
    End If
  Next Index
  
  For Index = 10 To 30
    Line = Index
    Line = Line + "- "
    If LeagueEntrants(Index - 1).Name = "" Then LeagueEntrants(Index - 1).Name = "EMPTY.TXT"
    Line = Line + left(LeagueEntrants(Index - 1).Name, Len(LeagueEntrants(Index - 1).Name) - 4)
    Line = Line + LeagueEntrants(Index - 1).Leaguefilecomment
    Print #2, Line
  Next Index
  
  Close #1
  Close #2
  
  If Dir$(MDIForm1.MainDir + "\Leagues\" + Leaguename + "leaguetable.bak") = " " Then
    Kill MDIForm1.MainDir + "\Leagues\" + Leaguename + "leaguetable.bak"
  End If
  
  'move leaguetable.txt to leaguetable.bak.
  If Not originalleague Then
    Name MDIForm1.MainDir + "\Leagues\" + Leaguename + "leaguetable.txt" As MDIForm1.MainDir + "\Leagues\" + Leaguename + "leaguetable.bak"
  End If
  
  'replace leaguetable.txt with leaguetable.tmp
  Name MDIForm1.MainDir + "\Leagues\" + Leaguename + "leaguetable.tmp" As MDIForm1.MainDir + "\Leagues\" + Leaguename + "leaguetable.txt"
  
  Exit Function
  
Nosuchfile:
  Close #1
  originalleague = True
  GoTo enderror
  
Problem:
  Close #1
  Close #2
  MsgBox "Error writing to " + MDIForm1.MainDir + "\Leagues\" + Leaguename + "leaguetable.tmp.  Abandoning save attempt.", vbOKOnly, "Save file error"
  Save_League_File = -1
  Exit Function
End Function
